Codeforces Round 1004 (Div. 1) C. Bitwise Slides

Codeforces Round 1004 (Div. 1) C. Bitwise Slides

题意:

  • 给你一个数组,三个整数P,Q,R​

  • 每一个操作使得P,Q,R三个数中的某个数异或s[i]

  • 每一步操作后需要保证三个数中至少两个数相同,问合法操作的种类数

思路:

首先考虑二维 d p dp dp,假设当前三个数为上一次操作后三个数为 i,i,j,那么 d p i , j dp_{i,j} dpi,j代表上次操作产生i,i,j​的种类数

假设当前的数为s[i]​,那么那么有以下转移方程:
d p 0 0 × 3 → d p 0 s \[ i ] d p i j → d p i j ⊕ s \[ i ] if j ⊕ s i ≠ i d p i j × 2 → d p j i if j ⊕ s i = i \begin{aligned} dp00 \times 3 &\rightarrow dp0s\[i] \\ dpij &\rightarrow dpij \\oplus s\[i] \quad \text{if} \ j \oplus si \neq i \\ dpij \times 2 &\rightarrow dpji \quad \text{if} \ j \oplus si = i \end{aligned} dp00×3dpijdpij×2→dp0s\[i]→dpij⊕s\[i]if j⊕si=i→dpjiif j⊕si=i

我们发现,只记录 y = i ⊕ j y=i \oplus j y=i⊕j可以使得
d p ′ y = ∑ i = j ⊕ y d p i j dp^{'}y=\sum _{i=j \oplus y} dpij dp′y=i=j⊕y∑dpij

这样,转移方程变为:
d p 0 × 3 → d p s \[ i ] d p s \[ i ] → 2 × d p s \[ i ] d p i → d p i ⊕ s \[ i ] for all i \begin{aligned} dp0 \times 3 &\rightarrow dps\[i] \\ dps\[i] &\rightarrow 2 \times dps\[i] \\ dpi &\rightarrow dpi \\oplus s\[i] \quad \text{for all} \ i \end{aligned} dp0×3dps\[i]dpi→dps\[i]→2×dps\[i]→dpi⊕s\[i]for all i

由此我们可以写出以下代码:

cpp 复制代码
		map<int, int> dp;
        dp[s[0]] = 3;
        for (int i = 1; i < n; i++)
        {
            map<int, int> tem;
            for (auto j : dp)
            {
                if (j.first == s[i])
                    tem[s[i]] = (tem[s[i]] + (dp[j.first] * 2) % mod) % mod;
                if (j.first != 0)
                    tem[j.first ^ s[i]] = (tem[j.first ^ s[i]] + dp[j.first]) % mod;
                else
                    tem[j.first ^ s[i]] = (tem[j.first ^ s[i]] + (dp[j.first] * 3) % mod) % mod;
            }
            dp = tem;
        }

我们发现设置一个tag能将所有 d p x dpx dpx 整体变为 d p x ⊕ s \[ i ] dpx \\oplus s\[i] dpx⊕s\[i],于是有了以下优化

cpp 复制代码
		map<int, int> dp;
        dp[s[0]] = 3;
        for (int i = 1; i < n; i++)
            dp[now] = (dp[now] * 3) % mod, dp[now] = (dp[now] + (dp[now ^ s[i]] * 2) % mod) % mod, now ^= s[i];

从左到右枚举所有数后 ,答案为 ∑ d p i \sum dpi ∑dpi

cpp 复制代码
#include <bits/stdc++.h>
using namespace std;
#define int long long int
#define Paddi ios::sync_with_stdio(false), cin.tie(0), cout.tie(0)
const int mod = 1e9 + 7;
signed main()
{
    Paddi;
    int T;
    cin >> T;
    while (T--)
    {
        int n;
        cin >> n;
        vector<int> s(n);
        for (int i = 0; i < n; i++)
            cin >> s[i];
        int ans = 0;
        int now = 0;
        map<int, int> dp;
        dp[s[0]] = 3;
        for (int i = 1; i < n; i++)
            dp[now] = (dp[now] * 3) % mod, dp[now] = (dp[now] + (dp[now ^ s[i]] * 2) % mod) % mod, now ^= s[i];
        for (auto i : dp)
            ans = (ans + i.second) % mod;
        cout << ans % mod << endl;
    }
    return 0;
}
相关推荐
曦樂~18 小时前
Cpp面筋
c语言·c++
道尔柯南18 小时前
C++ string 类详解:从常用接口到深拷贝,彻底掌握字符串处理
android·java·c++
Dream it possible!21 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊21 小时前
算法之双指针系列(一)
算法·leetcode
十二21 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方1 天前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi1 天前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH1 天前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi1 天前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展
zjxtxdy1 天前
C++面向对象程序开发-类与对象
开发语言·c++